﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace Parambulator
{

    public partial class DragDropStackPanel : UserControl
    {
        public DragDropStackPanel()
        {
            InitializeComponent();
            sp.Tag = this;
            sp.RequestBringIntoView += sp_RequestBringIntoView;
        }

        void sp_RequestBringIntoView(object sender, RequestBringIntoViewEventArgs e)
        {
            e.Handled = true;
        }

        public Action<FrameworkElement> drag_drop_action;

        private bool _isDown;
        private bool _isDragging;
        private Point _startPoint;
        public static FrameworkElement _realDragSource = new FrameworkElement();
        public static bool ok_to_drag = true;
        private FrameworkElement _dummyDragSource = new FrameworkElement();

        private void sp_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            if (e.Source == this.sp) { }
            else
            {
                _isDown = true;
                _startPoint = e.GetPosition(this.sp);
            }
        }

        private void sp_PreviewMouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            _isDown = false;
            _isDragging = false;
            if (_realDragSource == null) return;
            _realDragSource.ReleaseMouseCapture();
            _realDragSource = null;
        }

        private void sp_PreviewMouseMove(object sender, MouseEventArgs e)
        {
            if (!ok_to_drag) { sp_PreviewMouseLeftButtonUp(null, null); ok_to_drag = true; }
            if (_isDown)
            {
                if ((_isDragging == false) && ((Math.Abs(e.GetPosition(this.sp).X - _startPoint.X) > SystemParameters.MinimumHorizontalDragDistance) ||
                    (Math.Abs(e.GetPosition(this.sp).Y - _startPoint.Y) > SystemParameters.MinimumVerticalDragDistance)))
                {
                    _isDragging = true;
                    _realDragSource = e.Source as FrameworkElement;
                    _realDragSource.CaptureMouse();
                    DragDrop.DoDragDrop(_dummyDragSource, new DataObject("FrameworkElement", e.Source, true), DragDropEffects.Move);
                }
            }
        }

        private void sp_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent("FrameworkElement"))
            {
                e.Effects = DragDropEffects.Move;
            }
        }

        private void sp_Drop(object sender, DragEventArgs e)
        {
            if (_realDragSource == null) return;
            if (e.Data.GetDataPresent("FrameworkElement"))
            {
                FrameworkElement droptarget = e.Source as FrameworkElement;
                int droptargetIndex = -1, i = 0;
                foreach (FrameworkElement element in this.sp.Children)
                {
                    if (element.Equals(droptarget))
                    {
                        droptargetIndex = i;
                        break;
                    }
                    i++;
                }
                if (droptargetIndex != -1)
                {
                    if (_realDragSource.Parent.GetType() != typeof(StackPanel)) return;
                    StackPanel source_sp = (StackPanel)_realDragSource.Parent;
                    if (source_sp.Tag.GetType() != typeof(DragDropStackPanel)) return;
                    DragDropStackPanel ddsp = (DragDropStackPanel)source_sp.Tag;
                    source_sp.Children.Remove(_realDragSource);
                    //if (source_sp != sp && drag_drop_action != null) ddsp.drag_drop_action(_realDragSource);
                    this.sp.Children.Insert(droptargetIndex, _realDragSource);
                }
                _isDown = false;
                _isDragging = false;
                _realDragSource.ReleaseMouseCapture();
                if (drag_drop_action != null) drag_drop_action(_realDragSource);
            }
        }

        public void Add(FrameworkElement fe)
        {
            sp.Children.Add(fe);
        }


        public void Remove(FrameworkElement fe)
        {
            sp.Children.Remove(fe);
        }

        public List<FrameworkElement> items
        {
            get
            {
                return sp.Children.Cast<FrameworkElement>().ToList();
            }
        }

        public void Clear()
        {
            sp.Children.Clear();
        }

        public void set_horizontal()
        {
            sp.Orientation = Orientation.Horizontal;
        }

        public void set_vertical()
        {
            sp.Orientation = Orientation.Vertical;
        }
    }
}

