﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using BuzzGUI.Common;
using BuzzGUI.Interfaces;

namespace Parambulator
{

    public partial class MachineSelectorDialog : UserControl
    {
        public Action<List<IMachine>> OKAction;
        List<IMachine> this_list = new List<IMachine>();
        PersistentWindow my_window;

        public MachineSelectorDialog(List<IMachine> current_machines, PersistentWindow w, Action<List<IMachine>> handler)
        {
            InitializeComponent();
            this_list = current_machines;
            OKAction += handler;
            my_window = w;
            my_window.Closing += (o, e) => OKAction -= handler;
            foreach (IMachine im in Global.Buzz.Song.Machines)
            {
                CheckBox cb = new CheckBox() { Tag = im, Content = im.Name };
                cb.IsChecked = this_list.Contains(im);
                cb.Checked += checked_unchecked;
                cb.Unchecked += checked_unchecked;
                machine_selector_stack.Children.Add(cb);
            } 
        }

        private void checked_unchecked(object sender, RoutedEventArgs e)
        {
            CheckBox cb = sender as CheckBox;
            IMachine im = (IMachine)cb.Tag;
            bool selected = (bool)cb.IsChecked;
            bool found = false;
            foreach (IMachine m in this_list)
            {
                if (m == im)
                {
                    found = true;
                    break;
                }
            }
            if (selected && !found) this_list.Add(im);
            else if (!selected) this_list.Remove(im);
        }

        private void OK_Click(object sender, RoutedEventArgs e)
        {
            OKAction?.Invoke(this_list);
            my_window.Content = null;
            my_window.Close();
        }

        private void Cancel_Click(object sender, RoutedEventArgs e)
        {
            my_window.Content = null;
            my_window.Close();
        }
    }
}
