﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using BuzzGUI.Interfaces;

namespace Parambulator
{

    public partial class ParamSelectorProxy : UserControl
    {

        public ParameterModel param_model {get; set;}
        public bool is_selected {get; set;}

        public ParamSelectorProxy(IParameter ip, int trk, bool selected)
        {
            InitializeComponent();
            param_model = new ParameterModel(ip);
            param_model.track = trk;
            param_name_display.Text = ip.Name;
            is_selected = selected;
            selector_box.IsChecked = is_selected;
            selector_box.Checked += select_deselect;
            selector_box.Unchecked += select_deselect;
            if (ip.Group.Type == ParameterGroupType.Global) track_spinner.Visibility = Visibility.Collapsed;
            else
            {
                track_spinner.Value = param_model.track;
                track_spinner.ValueChanged += (o, e) => param_model.track = (int)track_spinner.Value;
            }
        }

        private void select_deselect(object sender, RoutedEventArgs e)
        {
            CheckBox cb = sender as CheckBox;
            is_selected = (bool)cb.IsChecked;
        }
    }
}
