﻿using BuzzGUI.Common;
using System;
using System.Windows;
using System.Windows.Interop;


namespace Parambulator
{
    public class PersistentWindow : Window
    {

        public PersistentWindow() : base()
        {
            var helper = new WindowInteropHelper(this);
            helper.Owner = Global.Buzz.MachineViewHWND;
        }

        public PersistentWindow(FrameworkElement fe)
            : this()
        {
            Content = fe;
        }

        public void topmost(bool value)
        {
            Topmost = value;
        }

        public bool keep_alive = true;

        protected override void OnClosing(System.ComponentModel.CancelEventArgs e)
        {
            base.OnClosing(e);
            if (keep_alive)
            {
                e.Cancel = true;
                this.Hide();
            }
        }

        public void destroy()
        {
            keep_alive = false;
            this.Close();
        }
    }

}

